VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WinMergeScript"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'/////////////////////////////////////////////////////////////////////////////
'    This is a plugin for WinMerge.
'    It will display the text content of MS Powerpoint files.
'    Contributed by March Hare Software Ltd February 2006
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
'
'/////////////////////////////////////////////////////////////////////////////
'
' RCS ID line follows -- this is updated by CVS
' $Id: WinMergeScript.cls,v 1.1 2005/11/06 03:00:16 christianlist Exp $

Option Explicit

Dim myLastErrorNumber As Long
Dim myLastErrorString As String

Private Declare Function GetTempPath Lib "kernel32" _
    Alias "GetTempPathA" (ByVal nBufferLength As Long, _
    ByVal lpBuffer As String) As Long

Private Declare Function GetTempFileName Lib "kernel32" _
    Alias "GetTempFileNameA" (ByVal lpszPath As String, _
    ByVal lpPrefixString As String, ByVal wUnique As Long, _
    ByVal lpTempFileName As String) As Long

Public Property Get PluginEvent() As String
  ' MsgBox "PluginEvent"
    PluginEvent = "FILE_PACK_UNPACK"
End Property

Public Property Get PluginDescription() As String
  ' MsgBox "PluginDescription"
    PluginDescription = "Display the text content of MS Powerpoint files."
End Property

Public Property Get PluginFileFilters() As String
  ' MsgBox "PluginFileFilters"
    PluginFileFilters = "\.ppt$"
End Property

Public Property Get PluginIsAutomatic() As Boolean
  ' MsgBox "PluginIsAutomatic"
    PluginIsAutomatic = True
End Property

Public Property Get LastErrorNumber() As Long
  ' MsgBox "LastErrorNumber"
LastErrorNumber = myLastErrorNumber
End Property
Public Property Get LastErrorString() As String
  ' MsgBox "LastErrorString"
LastErrorString = myLastErrorString
End Property
Private Function GetNumberMacros(objPPT) As Long
    Dim oTextToSave As String
    
    GetNumberMacros = 0
    On Error GoTo NoMacros
    If Not objPPT.VBProject Is Nothing Then
        If Not objPPT.VBProject.VBComponents Is Nothing Then
            GetNumberMacros = objPPT.VBProject.VBComponents.Count
        End If
    End If
  Exit Function
    
NoMacros:
    If Err = -2147188160 Or Err = -2146822220 Or Err = 6068 Then
        oTextToSave = "Cannot get Macros." & Error(Err) & " " & vbCrLf & "   To allow WinMerge to compare macros, use MS Office to alter the settings in the Macro Security for the current application." & vbCrLf & "   Open Macro Security dialog using the pulldown menu Tools->Macro->Security." & vbCrLf & "   In Office XP - use the Trusted Sources tab.  In Office 2003 - use the Trusted Publishers tab." & vbCrLf & "   The Trust access to Visual Basic Project feature should be turned on to use this feature in WinMerge."
        MsgBox "Error " & Err & ". " & oTextToSave, vbInformation
    Else
        MsgBox "Error " & Err & ". " & Error(Err), vbCritical
    End If
    
    GetNumberMacros = 0

End Function


Private Function GetMacrosHead(objPPT) As String
    Dim oTextToSave As String
    
    oTextToSave = ""
    On Error GoTo NoMacrosHead
    If Not objPPT.VBProject Is Nothing Then
        ' MsgBox "objPPT.VBProject is not Nothing"
        oTextToSave = oTextToSave + "The VB Project Name is " & objPPT.VBProject.Name & vbCrLf
        If Not objPPT.VBProject.VBComponents Is Nothing Then
            ' MsgBox "objPPT.VBProject.VBComponents is not Nothing"
            oTextToSave = oTextToSave + "There are " & objPPT.VBProject.VBComponents.Count & _
                " Microsoft Powerpoint macros in this presentation." & vbCrLf
            ' MsgBox "Listed how many macros there are OK"
        End If
    End If
    GetMacrosHead = oTextToSave
  Exit Function
    
NoMacrosHead:
    If Err = -2147188160 Or Err = -2146822220 Or Err = 6068 Then
        oTextToSave = "Cannot get Macros." & Error(Err) & " " & vbCrLf & "   To allow WinMerge to compare macros, use MS Office to alter the settings in the Macro Security for the current application." & vbCrLf & "   Open Macro Security dialog using the pulldown menu Tools->Macro->Security." & vbCrLf & "   In Office XP - use the Trusted Sources tab.  In Office 2003 - use the Trusted Publishers tab." & vbCrLf & "   The Trust access to Visual Basic Project feature should be turned on to use this feature in WinMerge."
        ' MsgBox "Error " & Err & ". " & oTextToSave, vbInformation
    Else
        oTextToSave = oTextToSave + "There are no Microsoft Powerpoint macros in this presentation." & vbCrLf
        MsgBox "Error " & Err & ". " & Error(Err), vbCritical
    End If
    
    GetMacrosHead = oTextToSave

End Function

Private Function GetTheMacros1(objPPT As Object, ProjectComponents As Long) As String

    Dim VBComp As Object
    Dim iCountMacros As Integer
    Dim oMacroLine As String
    Dim oTextToSave As String
    Dim macTempPaths() As String
    Dim hFile As Long
    
    On Error GoTo AfterMacros1
    iCountMacros = 0

    If ProjectComponents > 0 Then
        ' MsgBox "ReDim macTempPaths"
        ReDim macTempPaths(ProjectComponents - 1) As String
    End If
    
    If ProjectComponents > 0 Then
        oTextToSave = oTextToSave & "Macros in presentation" & vbCrLf
        For Each VBComp In objPPT.VBProject.VBComponents
            oTextToSave = oTextToSave & VBComp.Name & vbCrLf
    
            macTempPaths(iCountMacros) = CreateTempFile("WMS")
    
            ' Remove the temporary file
            Kill macTempPaths(iCountMacros)
    
            ' Save the text content of the macro
            VBComp.Export macTempPaths(iCountMacros)
    
            ' Read the content back from the file
            hFile = FreeFile
            Open macTempPaths(iCountMacros) For Input Shared As #hFile
            'oTextToSave = oTextToSave + macTempPaths(iCountMacros) + vbCrLf
            
            Do While Not EOF(1)   ' Loop until end of file.
               Line Input #hFile, oMacroLine   ' Read line into variable.
    
               oTextToSave = oTextToSave + oMacroLine + vbCrLf
            Loop
    
            Close #hFile
    
            oTextToSave = oTextToSave + vbCrLf
            iCountMacros = iCountMacros + 1
        'Next VBComp
        Next
        oTextToSave = oTextToSave & vbCrLf
    End If
    
    GetTheMacros1 = oTextToSave
  Exit Function
    
AfterMacros1:
    If Err = -2147188160 Or Err = -2146822220 Or Err = 6068 Then
        oTextToSave = "Cannot get Macros." & Error(Err) & " " & vbCrLf & "   To allow WinMerge to compare macros, use MS Office to alter the settings in the Macro Security for the current application." & vbCrLf & "   Open Macro Security dialog using the pulldown menu Tools->Macro->Security." & vbCrLf & "   In Office XP - use the Trusted Sources tab.  In Office 2003 - use the Trusted Publishers tab." & vbCrLf & "   The Trust access to Visual Basic Project feature should be turned on to use this feature in WinMerge."
        ' MsgBox "Error " & Err & ". " & oTextToSave, vbInformation
    Else
        MsgBox "Error " & Err & ". " & Error(Err), vbCritical
    End If
    
    GetTheMacros1 = oTextToSave

End Function
Private Function GetTheMacros2(objPPT As Object) As String
    Dim VBComp As Object
    Dim iCountMacros As Integer
    Dim oMacroLine As String
    Dim oTextToSave As String
    Dim macTempPaths() As String
    Dim hFile As Long
    
    On Error GoTo AfterMacros2
    
    oTextToSave = ""
    If Not objPPT.VBProject.VBComponents Is Nothing Then
        ' MsgBox "objPPT.VBProject.VBComponents is not nothing"
        If objPPT.VBProject.VBComponents.Count > 0 Then
            ' MsgBox "objPPT.VBProject.VBComponents.Count > 0"
            ' MsgBox "ReDim macTempPaths"
            ReDim macTempPaths(objPPT.VBProject.VBComponents.Count - 1) As String
            oTextToSave = oTextToSave & "Macros in document" & vbCrLf
        Else
            ' MsgBox "objPPT.VBProject.VBComponents.Count <= 0"
        End If
    End If
    
    iCountMacros = 0
    
    For Each VBComp In objPPT.VBProject.VBComponents
        ' VBComp = objPPT.VBProject.VBComponents(iCountMacros)
        oTextToSave = oTextToSave & VBComp.Name & vbCrLf
        
        macTempPaths(iCountMacros) = CreateTempFile("WMS")
        
        'MsgBox "Remove the temporary file"
        ' Remove the temporary file
        Kill macTempPaths(iCountMacros)

        'MsgBox "Save the text content of the macro"
        ' Save the text content of the macro
        VBComp.Export macTempPaths(iCountMacros)
        
        'MsgBox "Read the content back from the file"
        ' Read the content back from the file
        hFile = FreeFile
        Open macTempPaths(iCountMacros) For Input Shared As #hFile
        'oTextToSave = oTextToSave + macTempPaths(iCountMacros) + vbCrLf
        
        'MsgBox "Put in heading"
        Do While Not EOF(1)   ' Loop until end of file.
           Line Input #hFile, oMacroLine   ' Read line into variable.
           
            'MsgBox "add a line" & oMacroLine
           oTextToSave = oTextToSave + oMacroLine + vbCrLf
        Loop
        
        'MsgBox "close the file"
        Close #hFile

        oTextToSave = oTextToSave + vbCrLf
        iCountMacros = iCountMacros + 1
    'Next VBComp
    Next
    
    GetTheMacros2 = oTextToSave
  Exit Function

AfterMacros2:
    If Err = -2147188160 Or Err = -2146822220 Or Err = 6068 Then
        oTextToSave = "Cannot get Macros." & Error(Err) & " " & vbCrLf & "   To allow WinMerge to compare macros, use MS Office to alter the settings in the Macro Security for the current application." & vbCrLf & "   Open Macro Security dialog using the pulldown menu Tools->Macro->Security." & vbCrLf & "   In Office XP - use the Trusted Sources tab.  In Office 2003 - use the Trusted Publishers tab." & vbCrLf & "   The Trust access to Visual Basic Project feature should be turned on to use this feature in WinMerge."
        ' MsgBox "Error " & Err & ". " & oTextToSave, vbInformation
    Else
        MsgBox "Error " & Err & ". " & Error(Err), vbCritical
    End If
    
    GetTheMacros2 = oTextToSave

End Function
Private Function GetComponentCount(objPPT As Object)
'  Returns 0 if there is a problem accessing VBComponents
  On Error GoTo ErrHandler
  
  ' MsgBox "in GetComponentCount"
  GetComponentCount = 0
  If Not objPPT.VBProject Is Nothing Then
    ' MsgBox "objPPT.VBProject is not Nothing "
      If Not objPPT.VBProject.VBComponents Is Nothing Then
          ' MsgBox "objPPT.VBProject.VBComponents is not Nothing "
          GetComponentCount = objPPT.VBProject.VBComponents.Count
      End If
  End If
  ' MsgBox "leave GetComponentCount"
  
  Exit Function

ErrHandler:
  ' MsgBox "GetComponentCount error handler"
  GetComponentCount = 0
End Function

Private Function GetDocProperty(objPPT As Object, pName As String)
  On Error GoTo ErrHandler2
  
  GetDocProperty = ""
  If Not objPPT.BuiltinDocumentProperties.Item(pName) Is Nothing Then
      GetDocProperty = objPPT.BuiltinDocumentProperties.Item(pName).Value
  End If
  
  Exit Function

ErrHandler2:
  GetDocProperty = ""
End Function

Public Function UnpackFile(fileSrc As String, fileDst As String, ByRef bChanged As Boolean, ByRef subcode As Long) As Boolean
    On Error GoTo CleanUp
    
    myLastErrorNumber = 0
    myLastErrorString = ""
    
    ' MsgBox "Begin"

    ' Start MS Powerpoint
    Dim objPD As Object
    Set objPD = CreateObject("Powerpoint.Application")
    
    ' MsgBox "Created MS Powerpoint"
    
    ' Start MS Word
    Dim objWD As Object
    Set objWD = CreateObject("Word.Application")
    
    ' MsgBox "Created MS Word"
    
    ' ********************************
    ' **** The real stuff begins here
    ' ********************************
    ' Load the workbook into MS Powerpoint with the default title and no window
    Dim objPPT As Object
    
    ' MsgBox "About to open powerpoint presentation: " + fileSrc
    
    Set objPPT = objPD.Presentations.Open(fileSrc, True, False, False)

    ' MsgBox "Opened powerpoint presentation OK"
    
    ' Create an array of temporary paths
    ' These temporary files are needed because we can only output one macro at a time in export format
    Dim rtfTempPath As String

    ' this contains all the text that will be shown to the user
    Dim oTextToSave As String
    oTextToSave = ""
    
    ' (ProjectComponents may be zero due to Code Access Security)
    Dim ProjectComponents As Long
    
    On Error Resume Next
    ' MsgBox "About to get the project component count"
    ' ProjectComponents = GetComponentCount(objPPT)
    ' MsgBox "Got the project component count = " + ProjectComponents
    ' On Error GoTo CleanUp
    
    oTextToSave = oTextToSave & "Presentation Properties" & vbCrLf
    ProjectComponents = GetNumberMacros(objPPT)
    
    oTextToSave = oTextToSave & GetMacrosHead(objPPT)
    
    Dim itemValue As String
    Dim hFile As Long
    
    ' MsgBox "Get the document properties"
    ' Get the document properties
    Dim p As Object
    On Error Resume Next
    
    For Each p In objPPT.BuiltinDocumentProperties
        oTextToSave = oTextToSave + p.Name
        oTextToSave = oTextToSave + " = "
        itemValue = GetDocProperty(objPPT, p.Name)
        If itemValue <> "" Then
            oTextToSave = oTextToSave + itemValue
        End If
        oTextToSave = oTextToSave + vbCrLf
    Next
    On Error GoTo CleanUp
    
    ' MsgBox "End Document Properties"
    oTextToSave = oTextToSave + vbCrLf
    
    ' MsgBox "Get the macros"
    ' Get the Macros
    oTextToSave = oTextToSave + GetTheMacros2(objPPT)
    On Error GoTo CleanUp
    
    oTextToSave = oTextToSave & vbCrLf
   
    ' MsgBox "Get the Name"
    On Error Resume Next
    oTextToSave = oTextToSave + objPPT.Name + vbCrLf
                
    rtfTempPath = CreateTempFile("WMS")
        
    ' Remove the temporary file
    Kill rtfTempPath
    
    ' MsgBox "Save the text content of the presentation as an RTF file"
    ' Save the text content of the presentation as rich text file (RTF format)
    objPPT.SaveAs rtfTempPath, 6 ' ppSaveAsRTF
        
    ' MsgBox "Load the RTF file into MS Word"
    ' Load the document into MS Word
    Dim objRTF As Object
    Set objRTF = objWD.Documents.Open(rtfTempPath)

    ' MsgBox "Add the RTF text to oTextToSave"
    oTextToSave = oTextToSave + objRTF.Content.Text + vbCrLf
        
    ' MsgBox "Close the RTF file"
    ' Close the RTF file without saving changes
    objRTF.Close False
    
    oTextToSave = oTextToSave + vbCrLf
    On Error GoTo CleanUp
    
    
    ' MsgBox "Save the collected text"
    ' Save the collected text
    hFile = FreeFile
    Open fileDst For Output Shared As #hFile
    Print #hFile, oTextToSave
    Close #hFile

    ' MsgBox "Close the powerpoint slideshow"
    ' Close the presentation without saving changes
    objPPT.Close
    
    ' MsgBox "Kill the temporary file"
    ' Now kill the temporary file
    Kill rtfTempPath
    
    bChanged = True
    UnpackFile = True
    subcode = 1
    
CleanUp:
    ' MsgBox "Cleanup"
    myLastErrorNumber = Err
    myLastErrorString = CStr(Err) & ": " & Error(myLastErrorNumber)

    ' MsgBox "Stop MS Powerpoint"
    If Not objPD Is Nothing Then
        ' Stop MS Powerpoint
        objPD.Quit
    End If
    ' MsgBox "Stop MS Word"
    If Not objWD Is Nothing Then
        ' Stop MS Word
        objWD.Quit
    End If
    ' MsgBox "Bye"
End Function
 
Public Function PackFile(fileSrc As String, fileDst As String, ByRef bChanged As Boolean, subcode As Long) As Boolean
    ' We can't repack MS Powerpoint files
    bChanged = False
    PackFile = False
    subcode = 1
End Function

' Returns complete path and name for a temporary file
Private Function CreateTempFile(sPrefix As String) As String
    Dim sTmpPath As String * 512
    Dim sTmpName As String * 576
    Dim nRet As Long
    
    nRet = GetTempPath(512, sTmpPath)
    If (nRet > 0 And nRet < 512) Then
        nRet = GetTempFileName(sTmpPath, sPrefix, 0, sTmpName)
        If nRet <> 0 Then
            CreateTempFile = Left$(sTmpName, InStr(sTmpName, vbNullChar) - 1)
        End If
    End If
End Function

